Index: gnu/usr.bin/perl/pod/perl5421delta.pod
===================================================================
RCS file: gnu/usr.bin/perl/pod/perl5421delta.pod
diff -N gnu/usr.bin/perl/pod/perl5421delta.pod
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gnu/usr.bin/perl/pod/perl5421delta.pod	29 Mar 2026 16:31:45 -0000
@@ -0,0 +1,209 @@
+=encoding utf8
+
+=head1 NAME
+
+perl5421delta - what is new for perl v5.42.1
+
+=head1 DESCRIPTION
+
+This document describes differences between the 5.42.0 release and the 5.42.1
+release.
+
+If you are upgrading from an earlier release such as 5.40.0, first read
+L<perl5420delta>, which describes differences between 5.40.0 and 5.42.0.
+
+=head1 Incompatible Changes
+
+There are no changes intentionally incompatible with Perl 5.42.0.  If any
+exist, they are bugs, and we request that you submit a report.  See
+L</Reporting Bugs> below.
+
+=head1 Modules and Pragmata
+
+=head2 Updated Modules and Pragmata
+
+=over 4
+
+=item *
+
+L<Module::CoreList> has been upgraded from version 5.20250702 to 5.20260308.
+
+=item *
+
+L<POSIX> has been upgraded from version 2.23 to 2.23_01.
+
+=back
+
+=head1 Documentation
+
+=head2 Changes to Existing Documentation
+
+We have attempted to update the documentation to reflect the changes listed in
+this document.  If you find any we have missed, open an issue at
+L<https://github.com/Perl/perl5/issues>.
+
+=head1 Configuration and Compilation
+
+=over 4
+
+=item *
+
+It is now possible to pass to F<Configure> the values dealing with POSIX locale
+categories, overriding its automatic calculation of these.  This enables
+cross-compilation to work.  The easiest way to do this is to extract the C
+program that does the calculation from F<Configure> and then run it on the
+target machine, and then pass the values it outputs to F<Configure> on the
+other machine.  F<Porting/Glossary> has examples.
+[L<GH #22992|https://github.com/Perl/perl5/issues/22992>]
+
+=back
+
+=head1 Testing
+
+Tests were added and changed to reflect the other additions and changes in this
+release.
+
+=head1 Platform Support
+
+=head2 Platform-Specific Notes
+
+=over 4
+
+=item AIX
+
+Thread-safe locale handling has been turned off on all releases due to
+apparent bugs in the underlying operating system support.
+[L<GH #23825|https://github.com/Perl/perl5/issues/23825>]
+
+=item Win32
+
+Fix builds with C<USE_IMP_SYS> defined but C<USE_ITHREADS> not defined.
+
+=back
+
+=head1 Selected Bug Fixes
+
+=over 4
+
+=item *
+
+S<C<use 5.42>> now turns on S<C<use source::encoding "ascii">> for the
+remainder of the line (besides subsequent lines).
+[L<GH #23881|https://github.com/Perl/perl5/issues/23881>]
+
+=item *
+
+Perl 5.42.0 does not handle the transition to/from daylight savings time
+properly.  The time and/or timezone can be off by an hour in the intervals
+surrounding such transitions.  This is a regression from earlier releases, and
+is now fixed.  This bug was evident from perl space in the L<POSIX/strftime>
+function, and in XS code with any of L<perlapi/my_strftime>,
+L<perlapi/sv_strftime_ints>, or L<perlapi/sv_strftime_tm>.
+[L<GH #23878|https://github.com/Perl/perl5/issues/23878>]
+
+=item *
+
+Certain constructs involving a two-variable C<for> loop would crash the perl
+compiler in Perl 5.42.0:
+
+    # Two-variable for loop over a list returned from a method call:
+    for my ($x, $y) (Some::Class->foo()) { ... }
+    for my ($x, $y) ($object->foo()) { ... }
+
+and
+
+    # Two-variable for loop over a list returned from a call to a
+    # lexical(ly imported) subroutine, all inside a lexically scoped
+    # or anonymous subroutine:
+    my sub foo { ... }
+    my $fn = sub {
+        for my ($x, $y) (foo()) { ... }
+    };
+
+    use builtin qw(indexed);  # lexical import!
+    my sub bar {
+        for my ($x, $y) (indexed(...)) { ... }
+    }
+
+These have been fixed.
+[L<GH #23405|https://github.com/Perl/perl5/issues/23405>]
+
+=item *
+
+Since Perl 5.32.0, the second branch of a ternary condition operator wasn't
+getting the correct autovivification context applied.  For example in something
+like
+
+    @{ $cond ? $h{foo} : $h{bar} } = ...;
+
+the first branch would correctly autovivify C<$h{foo}> to an array ref, but the
+second branch might incorrectly autovivify C<$h{bar}> to a hash ref.
+[L<GH #18669|https://github.com/Perl/perl5/issues/18669>].
+
+=back
+
+=head1 Acknowledgements
+
+Perl 5.42.1 represents approximately 8 months of development since Perl 5.42.0
+and contains approximately 7,200 lines of changes across 55 files from 12
+authors.
+
+Excluding auto-generated files, documentation and release tools, there were
+approximately 1,700 lines of changes to 16 .pm, .t, .c and .h files.
+
+Perl continues to flourish into its fourth decade thanks to a vibrant community
+of users and developers.  The following people are known to have contributed
+the improvements that became Perl 5.42.1:
+
+David Mitchell, Eric Herman, Karen Etheridge, Karl Williamson, Lukas Mai, Max
+Maischein, Philippe Bruhat (BooK), Richard Leach, Steve Hay, Thibault
+Duponchelle, Tony Cook, Yitzchak Scott-Thoennes.
+
+The list above is almost certainly incomplete as it is automatically generated
+from version control history.  In particular, it does not include the names of
+the (very much appreciated) contributors who reported issues to the Perl bug
+tracker.
+
+Many of the changes included in this version originated in the CPAN modules
+included in Perl's core. We're grateful to the entire CPAN community for
+helping Perl to flourish.
+
+For a more complete list of all of Perl's historical contributors, please see
+the F<AUTHORS> file in the Perl source distribution.
+
+=head1 Reporting Bugs
+
+If you find what you think is a bug, you might check the perl bug database at
+L<https://github.com/Perl/perl5/issues>.  There may also be information at
+L<https://www.perl.org/>, the Perl Home Page.
+
+If you believe you have an unreported bug, please open an issue at
+L<https://github.com/Perl/perl5/issues>.  Be sure to trim your bug down to a
+tiny but sufficient test case.
+
+If the bug you are reporting has security implications which make it
+inappropriate to send to a public issue tracker, then see
+L<perlsec/SECURITY VULNERABILITY CONTACT INFORMATION> for details of how to
+report the issue.
+
+=head1 Give Thanks
+
+If you wish to thank the Perl 5 Porters for the work we had done in Perl 5, you
+can do so by running the C<perlthanks> program:
+
+    perlthanks
+
+This will send an email to the Perl 5 Porters list with your show of thanks.
+
+=head1 SEE ALSO
+
+The F<Changes> file for an explanation of how to view exhaustive details on
+what changed.
+
+The F<INSTALL> file for how to build Perl.
+
+The F<README> file for general stuff.
+
+The F<Artistic> and F<Copying> files for copyright information.
+
+=cut
Index: gnu/usr.bin/perl/pod/perldelta.pod
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/pod/perldelta.pod,v
diff -u -p -a -u -p -r1.29 perldelta.pod
--- gnu/usr.bin/perl/pod/perldelta.pod	26 Dec 2025 22:14:21 -0000	1.29
+++ gnu/usr.bin/perl/pod/perldelta.pod	29 Mar 2026 16:31:45 -0000
@@ -2,318 +2,35 @@
 
 =head1 NAME
 
-perldelta - what is new for perl v5.42.0
+perldelta - what is new for perl v5.42.2
 
 =head1 DESCRIPTION
 
-This document describes differences between the 5.42.0 release and the 5.40.0
+This document describes differences between the 5.42.1 release and the 5.42.2
 release.
 
-=head1 Core Enhancements
-
-=head2 More CORE:: subs
-
-C<chdir> has been added as a subroutine to the C<CORE::> namespace.
-
-Previously, code like C<&CORE::chdir($dir)> or C<< my $ref = \&CORE::chdir;
-$ref->($dir) >> would throw an error saying C<&CORE::chdir cannot be called
-directly>. These cases are now fully supported.
-
-=head2 New pragma C<L<source::encoding>>
-
-This allows you to declare that the portion of a program for the
-remainder of the lexical scope of this pragma is encoded either entirely
-in ASCII (for S<C<use source::encoding 'ascii'>>) or if UTF-8 is allowed
-as well (for S<C<use source::encoding 'utf8'>>). No other encodings are
-accepted. The second form is entirely equivalent to S<C<use utf8>>, and
-may be used interchangeably with that.
-
-The purpose of this pragma is to catch cases early where you forgot to
-specify S<C<use utf8>>.
-
-S<C<use source::encoding 'ascii'>> is automatically enabled within the
-lexical scope of a S<C<use v5.41.0>> or higher.
-
-S<C<no source::encoding>> turns off all this checking for the remainder of
-its lexical scope. The meaning of non-ASCII characters is then undefined.
-
-=head2 New C<:writer> attribute on field variables
-
-Classes defined using C<use feature 'class'> are now able to automatically
-create writer accessors for scalar fields, by using the C<:writer> attribute,
-similar to the way that C<:reader> already creates reader accessors.
-
-    class Point {
-        field $x :reader :writer :param;
-        field $y :reader :writer :param;
-    }
-
-    my $p = Point->new( x => 20, y => 40 );
-    $p->set_x(60);
-
-=head2 New C<any> and C<all> operators
-
-Two new experimental features have been added, which introduce the
-list-processing operators C<any> and C<all>.
-
-    use v5.42;
-    use feature 'keyword_all';
-    no warnings 'experimental::keyword_all';
-
-    my @numbers = ...
-
-    if ( all { $_ % 2 == 0 } @numbers ) {
-        say "All the numbers are even";
-    }
-
-These keywords operate similarly to C<grep> except that they only
-ever return true or false, testing if any (or all) of the elements in
-the list make the testing block yield true.  Because of this they can
-short-circuit, avoiding the need to test any further elements if a given
-element determines the eventual result.
-
-These are inspired by the same-named functions in the L<List::Util> module,
-except that they are implemented as direct core operators, and thus perform
-faster, and do not produce an additional subroutine call stack frame for
-invoking the code block.
-
-The feature flags enabling those keywords have been named
-L<C<keyword_any>|feature/"The 'keyword_any' feature">
-and L<C<keyword_all>|feature/"The 'keyword_all' feature">
-to avoid confusion with the ability of the C<feature> module
-to refer to all of its features by using the C<:all>
-export tag.  [L<GH #23104|https://github.com/Perl/perl5/issues/23104>]
-
-The related experimental warning flags are consequently named
-C<experimental::keyword_any> and C<experimental::keyword_all>.
-
-=head2 Apostrophe as a global name separator can be disabled
-
-This was deprecated in Perl 5.38 and removed as scheduled in perl
-5.41.3, but after some discussion has been reinstated by default.
-
-This can be controlled with the C<apostrophe_as_package_separator>
-feature which is enabled by default, but is disabled from the 5.41
-feature bundle onwards.
-
-If you want to disable use within your own code you can explicitly
-disable the feature:
-
-  no feature "apostrophe_as_package_separator";
-
-Note that disabling this feature only prevents use of apostrophe as a
-package separator within code; symbolic references still treat C<'> as
-C<::> with the feature disabled:
-
-  my $symref = "My'Module'Var";
-  # default features
-  my $x = $My'Module'Var; # fine
-  no feature "apostrophe_as_package_separator";
-  no strict "refs";
-  my $y = $$symref;       # like $My::Module::Var
-  my $z = $My'Module'Var; # syntax error
-
-[L<GH #22644|https://github.com/Perl/perl5/issues/22644>]
-
-=head2 Lexical method declaration using C<my method>
-
-Like C<sub> since Perl version 5.18, C<method> can now be prefixed with the
-C<my> keyword.  This declares a subroutine that has lexical, rather than
-package visibility.  See L<perlclass> for more detail.
-
-=head2 Lexical method invocation operator C<< ->& >>
-
-Along with the ability to declare methods lexically, this release also permits
-invoking a lexical subroutine as if it were a method, bypassing the usual
-name-based method resolution.
-
-Combined with lexical method declaration, these two new abilities create the
-effect of having private methods.
-
-=head2 Switch and Smart Match operator kept, behind a feature
-
-The "switch" feature and the smartmatch operator, C<~~>, were introduced in
-v5.10.  Their behavior was significantly changed in v5.10.1.  When the
-"experiment" system was added in v5.18.0, switch and smartmatch were
-retroactively declared experimental.  Over the years, proposals to fix or
-supplement the features have come and gone.
-
-They were deprecated in Perl v5.38.0 and scheduled for removal in
-Perl v5.42.0. After extensive discussion their removal has been indefinitely
-postponed. Using them no longer produces a deprecation warning.
-
-Switch itself still requires the C<switch> feature, which is enabled
-by default for feature bundles from v5.9.5 through to v5.34.  Switch
-remains disabled in feature bundles 5.35 and later, but can be
-separately enabled:
-
-  # no switch here
-  use v5.10;
-  # switch here
-  use v5.36;
-  # no switch here
-  use feature "switch";
-  # switch here
-
-Smart match now requires the C<smartmatch> feature, which is enabled
-by default and included in all feature bundles up to 5.40.  It is
-disabled for the 5.41 feature bundle and later, but can be separately
-enabled:
-
-  # smartmatch here
-  use v5.41;
-  # no smartmatch here
-  use feature "smartmatch";
-  # smartmatch here
-
-[L<GH #22752|https://github.com/Perl/perl5/issues/22752>]
-
-=head2 Unicode 16.0 supported
-
-Perl now supports Unicode 16.0
-L<https://www.unicode.org/versions/Unicode16.0.0/> including the changes
-introduced in 15.1 L<https://www.unicode.org/versions/Unicode15.1.0/>.
-
-=head2 Assigning logical xor C<^^=> operator
-
-Perl 5.40.0 introduced the logical medium-precedence exclusive-or operator
-C<^^>.  It was not noticed at the time that the assigning variant C<^^=> was
-also missing.  This is now added.
+If you are upgrading from an earlier release such as 5.42.0, first read
+L<perl5421delta>, which describes differences between 5.42.0 and 5.42.1.
 
 =head1 Security
 
-=head2 [CVE-2024-56406] Heap buffer overflow vulnerability with tr//
-
-A heap buffer overflow vulnerability was discovered in Perl.
-
-When there are non-ASCII bytes in the left-hand-side of the C<tr> operator,
-C<S_do_trans_invmap()> can overflow the destination pointer C<d>.
+=head2 [CVE-2026-4176] Vulnerability in Compress::Raw::Zlib
 
-  $ perl -e '$_ = "\x{FF}" x 1000000; tr/\xFF/\x{100}/;'
-  Segmentation fault (core dumped)
+L<Compress::Raw::Zlib> is included in Perl as a dual-life core module, and was
+vulnerable to [L<CVE-2026-3381|https://www.cve.org/CVERecord?id=CVE-2026-3381>]
+due to a vendored version of zlib which had several vulnerabilities, including
+[L<CVE-2026-27171|https://www.cve.org/CVERecord?id=CVE-2026-27171>].
+
+This problem was assigned
+[L<CVE-2026-4176|https://www.cve.org/CVERecord?id=CVE-2026-4176>] by the
+L<CPAN Security Group|https://security.metacpan.org/>.
 
-It is believed that this vulnerability can enable Denial of Service or
-Arbitrary Code Execution attacks on platforms that lack sufficient defenses.
-
-This problem was discovered by Nathan Mills and assigned
-[L<CVE-2024-56406|https://lists.security.metacpan.org/cve-announce/msg/28708725/>]
-by the L<CPAN Security Group|https://security.metacpan.org/>.
-
-The patch to fix this issue (L<87f42aa0e0096e9a346c9672aa3a0bd3bef8c1dd|https://github.com/Perl/perl5/commit/87f42aa0e0096e9a346c9672aa3a0bd3bef8c1dd>) is applicable to all perls that are vulnerable, including those
-out-of-support.
-
-=head2 [CVE-2025-40909] Perl threads have a working directory race condition where file operations may target unintended paths
-
-Perl thread cloning had a working directory race condition where file
-operations may target unintended paths. Perl 5.42 will no longer chdir
-to each handle.
-
-This problem was discovered by Vincent Lefèvre via [L<GH #23010|https://github.com/Perl/perl5/issues/23010>]
-and assigned [L<CVE-2025-40909|https://lists.security.metacpan.org/cve-announce/msg/30017499/>]
-by the L<CPAN Security Group|https://security.metacpan.org/>.
-
-Fixes were provided via [L<GH #23019|https://github.com/Perl/perl5/pull/23019>]
-and [L<GH #23361|https://github.com/Perl/perl5/pull/23361>].
 
 =head1 Incompatible Changes
 
-=head2 Removed containing function references for functions without eval
-
-Perl 5.40 reintroduced unconditional references from functions to their
-containing functions to fix a bug introduced in Perl 5.18 that broke the
-special behaviour of C<eval EXPR> in package C<DB> which is used by the
-debugger.
-
-In some cases this change led to circular reference chains between closures and
-other existing references, resulting in memory leaks.
-
-This change has been reverted, fixing
-[L<GH #22547|https://github.com/Perl/perl5/issues/22547>] but re-breaking
-[L<GH #19370|https://github.com/Perl/perl5/issues/19370>].
-
-This means the reference loops won't occur, and that lexical variables and
-functions from enclosing functions may not be visible in the debugger.
-
-Note that calling C<eval EXPR> in a function unconditionally causes a function
-to reference its enclosing functions as it always has.
-
-=head1 Performance Enhancements
-
-=over 4
-
-=item *
-
-Constant-folded strings are now shareable via the Copy-on-Write mechanism.
-[L<GH #22163|https://github.com/Perl/perl5/pull/22163>]
-
-The following code would previously have allocated eleven string buffers,
-each containing one million "A"s:
-
-    my @scalars; push @scalars, ("A" x 1_000_000) for 0..9;
-
-Now a single buffer is allocated and shared between a CONST OP and
-the ten scalar elements of C<@scalars>.
-
-Note that any code using this sort of constant to simulate memory leaks
-(perhaps in test files) must now permute the string in order to trigger
-a string copy and the allocation of separate buffers. For example,
-C<("A" x 1_000_000).time> might be a suitable small change.
-
-=item *
-
-C<tr///> now runs at the same speed regardless of the internal
-representation of its operand, as long as the only characters being
-translated are ASCII-range, for example C<tr/A-Z/a-z/>.  Previously, if
-the internal encoding was UTF-8, a slower, more general implementation
-was used.
-
-=item *
-
-Code that uses the C<indexed> function from the L<builtin> module to generate
-a list of index/value pairs out of an array or list which is then passed into
-a two-variable C<foreach> list to unpack those again is now optimised to be
-more efficient.
-
-    my @array = (...);
-
-    foreach my ($idx, $val) (builtin::indexed @array) {
-        ...
-    }
-
-Z<>
-
-    foreach my ($idx, $val) (builtin::indexed LIST...) {
-        ...
-    }
-
-In particular, a temporary list twice the size of the original is no longer
-generated.  Instead, the loop iterates down the original array or list
-in-place directly, in the same way that C<foreach (@array)> or
-C<foreach (LIST)> would do.
-
-=item *
-
-The peephole optimizer recognises the following zero-offset C<substr> patterns
-and swaps in a new dedicated operator (C<OP_SUBSTR_LEFT>).
-[L<GH #22785|https://github.com/Perl/perl5/issues/22785>]
-
-    substr($x, 0, ...)
-    substr($x, 0, ..., '')
-
-=item *
-
-The stringification of integers by L<perlfunc/print> and L<perlfunc/say>,
-when coming from an C<SVt_IV>, is now more efficient.
-[L<GH #22927|https://github.com/Perl/perl5/issues/22927>]
-
-=item *
-
-String reversal from a single argument, when the string buffer is not
-"swiped", is now done in a single pass and is noticeably faster.
-The extent of the improvement is compiler & hardware dependent.
-[L<GH #23012|https://github.com/Perl/perl5/issues/23012>]
-
-=back
+There are no changes intentionally incompatible with 5.42.1.  If any exist,
+they are bugs, and we request that you submit a report.  See L</Reporting Bugs>
+below.
 
 =head1 Modules and Pragmata
 
